<?php 
/**
 * Multiple_values Page Controller
 * @category  Controller
 */
class Multiple_valuesController extends SecureController{
	function __construct(){
		parent::__construct();
		$this->tablename = "multiple_values";
	}
	/**
     * List page records
     * @param $fieldname (filter record by a field) 
     * @param $fieldvalue (filter field value)
     * @return BaseView
     */
	function index($fieldname = null , $fieldvalue = null){
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$fields = array("multiple_values.id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"portfolio.name AS portfolio_name", 
			"multiple_values.detailno", 
			"multiple_values.amount", 
			"multiple_values.col");
		$pagination = $this->get_pagination(MAX_RECORD_COUNT); // get current pagination e.g array(page_number, page_limit)
		//search table record
		if(!empty($request->search)){
			$text = trim($request->search); 
			$search_condition = "(
				multiple_values.id LIKE ? OR 
				multiple_values.empid LIKE ? OR 
				employee_details.employee_name LIKE ? OR 
				portfolio.name LIKE ? OR 
				multiple_values.detailno LIKE ? OR 
				multiple_values.amount LIKE ? OR 
				multiple_values.portid LIKE ? OR 
				multiple_values.col LIKE ? OR 
				employee_details.id LIKE ? OR 
				employee_details.portfolio_id LIKE ? OR 
				employee_details.basic_pay LIKE ? OR 
				employee_details.bank_acc_no LIKE ? OR 
				employee_details.bank_name LIKE ? OR 
				employee_details.email LIKE ? OR 
				employee_details.dob LIKE ? OR 
				employee_details.date_of_join LIKE ? OR 
				employee_details.date_of_retirement LIKE ? OR 
				employee_details.department LIKE ? OR 
				employee_details.IFSC LIKE ? OR 
				employee_details.designation LIKE ? OR 
				employee_details.caste LIKE ? OR 
				employee_details.relegion LIKE ? OR 
				employee_details.nominee LIKE ? OR 
				employee_details.payscale LIKE ? OR 
				employee_details.gender LIKE ? OR 
				employee_details.identification_mark LIKE ? OR 
				employee_details.place_of_birth LIKE ? OR 
				employee_details.balanceleave LIKE ? OR 
				portfolio.id LIKE ? OR 
				portfolio.pid LIKE ?
			)";
			$search_params = array(
				"%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%"
			);
			//setting search conditions
			$db->where($search_condition, $search_params);
			 //template to use when ajax search
			$this->view->search_template = "multiple_values/search.php";
		}
		$db->join("employee_details", "multiple_values.empid = employee_details.id", "INNER");
		$db->join("portfolio", "multiple_values.portid = portfolio.id", "INNER");
		if(!empty($request->orderby)){
			$orderby = $request->orderby;
			$ordertype = (!empty($request->ordertype) ? $request->ordertype : ORDER_TYPE);
			$db->orderBy($orderby, $ordertype);
		}
		else{
			$db->orderBy("multiple_values.id", ORDER_TYPE);
		}
		if($fieldname){
			$db->where($fieldname , $fieldvalue); //filter by a single field name
		}
		if(!empty($request->employee_details_portfolio_id)){
			$val = $request->employee_details_portfolio_id;
			$db->where("employee_details.portfolio_id", $val , "=");
		}
		$tc = $db->withTotalCount();
		$records = $db->get($tablename, $pagination, $fields);
		$records_count = count($records);
		$total_records = intval($tc->totalCount);
		$page_limit = $pagination[1];
		$total_pages = ceil($total_records / $page_limit);
		$data = new stdClass;
		$data->records = $records;
		$data->record_count = $records_count;
		$data->total_records = $total_records;
		$data->total_page = $total_pages;
		if($db->getLastError()){
			$this->set_page_error();
		}
		$page_title = $this->view->page_title = "Multiple Values";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		$this->render_view("multiple_values/list.php", $data); //render the full page
	}
	/**
     * View record detail 
	 * @param $rec_id (select record by table primary key) 
     * @param $value value (select record by value of field name(rec_id))
     * @return BaseView
     */
	function view($rec_id = null, $value = null){
		$request = $this->request;
		$db = $this->GetModel();
		$rec_id = $this->rec_id = urldecode($rec_id);
		$tablename = $this->tablename;
		$fields = array("multiple_values.id", 
			"multiple_values.empid", 
			"multiple_values.detailno", 
			"multiple_values.amount", 
			"multiple_values.portid", 
			"multiple_values.col", 
			"employee_details.id AS employee_details_id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"employee_details.portfolio_id AS employee_details_portfolio_id", 
			"employee_details.basic_pay AS employee_details_basic_pay", 
			"employee_details.bank_acc_no AS employee_details_bank_acc_no", 
			"employee_details.bank_name AS employee_details_bank_name", 
			"employee_details.email AS employee_details_email", 
			"employee_details.dob AS employee_details_dob", 
			"employee_details.date_of_join AS employee_details_date_of_join", 
			"employee_details.date_of_retirement AS employee_details_date_of_retirement", 
			"employee_details.department AS employee_details_department", 
			"employee_details.IFSC AS employee_details_IFSC", 
			"employee_details.designation AS employee_details_designation", 
			"employee_details.caste AS employee_details_caste", 
			"employee_details.relegion AS employee_details_relegion", 
			"employee_details.nominee AS employee_details_nominee", 
			"employee_details.payscale AS employee_details_payscale", 
			"employee_details.gender AS employee_details_gender", 
			"employee_details.identification_mark AS employee_details_identification_mark", 
			"employee_details.place_of_birth AS employee_details_place_of_birth", 
			"employee_details.balanceleave AS employee_details_balanceleave", 
			"portfolio.id AS portfolio_id", 
			"portfolio.name AS portfolio_name", 
			"portfolio.pid AS portfolio_pid");
		if($value){
			$db->where($rec_id, urldecode($value)); //select record based on field name
		}
		else{
			$db->where("multiple_values.id", $rec_id);; //select record based on primary key
		}
		$db->join("employee_details", "multiple_values.empid = employee_details.id", "INNER ");
		$db->join("portfolio", "multiple_values.portid = portfolio.id", "INNER ");  
		$record = $db->getOne($tablename, $fields );
		if($record){
			$page_title = $this->view->page_title = "View  Multiple Values";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		}
		else{
			if($db->getLastError()){
				$this->set_page_error();
			}
			else{
				$this->set_page_error("No record found");
			}
		}
		return $this->render_view("multiple_values/view.php", $record);
	}
	/**
     * Insert new record to the database table
	 * @param $formdata array() from $_POST
     * @return BaseView
     */
	function add($formdata = null){
		if($formdata){
			$db = $this->GetModel();
			$tablename = $this->tablename;
			$request = $this->request;
			//fillable fields
			$fields = $this->fields = array("empid","portid","col","detailno","amount");
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'empid' => 'required',
				'portid' => 'required',
				'col' => 'required',
				'detailno' => 'required',
				'amount' => 'required|numeric',
			);
			$this->sanitize_array = array(
				'empid' => 'sanitize_string',
				'portid' => 'sanitize_string',
				'col' => 'sanitize_string',
				'detailno' => 'sanitize_string',
				'amount' => 'sanitize_string',
			);
			$this->filter_vals = true; //set whether to remove empty fields
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			if($this->validated()){
				$rec_id = $this->rec_id = $db->insert($tablename, $modeldata);
				if($rec_id){
					$this->set_flash_msg("Record added successfully", "success");
					return	$this->redirect("multiple_values");
				}
				else{
					$this->set_page_error();
				}
			}
		}
		$page_title = $this->view->page_title = "Add New Multiple Values";
		$this->render_view("multiple_values/add.php");
	}
	/**
     * Update table record with formdata
	 * @param $rec_id (select record by table primary key)
	 * @param $formdata array() from $_POST
     * @return array
     */
	function edit($rec_id = null, $formdata = null){
		$request = $this->request;
		$db = $this->GetModel();
		$this->rec_id = $rec_id;
		$tablename = $this->tablename;
		 //editable fields
		$fields = $this->fields = array("id","empid","portid","col","detailno","amount");
		if($formdata){
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'empid' => 'required',
				'portid' => 'required',
				'col' => 'required',
				'detailno' => 'required',
				'amount' => 'required|numeric',
			);
			$this->sanitize_array = array(
				'empid' => 'sanitize_string',
				'portid' => 'sanitize_string',
				'col' => 'sanitize_string',
				'detailno' => 'sanitize_string',
				'amount' => 'sanitize_string',
			);
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			if($this->validated()){
				$db->where("multiple_values.id", $rec_id);;
				$bool = $db->update($tablename, $modeldata);
				$numRows = $db->getRowCount(); //number of affected rows. 0 = no record field updated
				if($bool && $numRows){
					$this->set_flash_msg("Record updated successfully", "success");
					return $this->redirect("multiple_values");
				}
				else{
					if($db->getLastError()){
						$this->set_page_error();
					}
					elseif(!$numRows){
						//not an error, but no record was updated
						$page_error = "No record updated";
						$this->set_page_error($page_error);
						$this->set_flash_msg($page_error, "warning");
						return	$this->redirect("multiple_values");
					}
				}
			}
		}
		$db->where("multiple_values.id", $rec_id);;
		$data = $db->getOne($tablename, $fields);
		$page_title = $this->view->page_title = "Edit  Multiple Values";
		if(!$data){
			$this->set_page_error();
		}
		return $this->render_view("multiple_values/edit.php", $data);
	}
	/**
     * Delete record from the database
	 * Support multi delete by separating record id by comma.
     * @return BaseView
     */
	function delete($rec_id = null){
		Csrf::cross_check();
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$this->rec_id = $rec_id;
		//form multiple delete, split record id separated by comma into array
		$arr_rec_id = array_map('trim', explode(",", $rec_id));
		$db->where("multiple_values.id", $arr_rec_id, "in");
		$bool = $db->delete($tablename);
		if($bool){
			$this->set_flash_msg("Record deleted successfully", "success");
		}
		elseif($db->getLastError()){
			$page_error = $db->getLastError();
			$this->set_flash_msg($page_error, "danger");
		}
		return	$this->redirect("multiple_values");
	}
}
